program mapEdit;
uses
  graph, dos, graphini, mausunit, mapserv, mndldemo;
const
  mHoehe = 15;
  maxplayer = 5;
  sMaxplayer = '5';
  versionText = 'vNibbles-Map-Editor ver 1.01';
var
  dateiname: string;
  maxx, maxy: word;
  bodenFarbe, wandFarbe, xmf: byte;
  feld: array[1..80, 1..24] of char;
  {32' ', 219'', 220'', 223''}

procedure erzeugeButton( name, beschreib, schrift: string;
                         xpos: word; farbe, cursor: byte );
begin
  setfillStyle(1, farbe);
  bar((maxx - xpos * 8 - 3), (maxy - 14),
    (maxx - (xpos - length(schrift)) * 8), maxy);
  outtextXY((maxx - xpos * 8), (maxy - 12), schrift);
  mausUnit.erzeugeFeld(name, beschreib, (maxx -  xpos * 8 - 3) * xmf, (maxy - 14),
    (maxx - (xpos - length(schrift)) * 8) * xmf, maxy, cursor, TRUE);
end;

procedure malFeld(x, y, farbe: byte);
begin
  versteckeCursor;
  setFillStyle(1, farbe);
  bar(round((x - 1) * maxx / 80), round((y - 1) * (maxy - mHoehe) / 48),
      round(x * maxx / 80 - 1), round(y * (maxy - mHoehe) / 48 - 1));
  zeigeCursor;
end;

function dunkel1( x: byte ): byte;
begin
  if odd(x) then dunkel1:= black else dunkel1:= darkgray;
end;

function dunkel2( x: byte ): byte;
begin
  if odd(x) then dunkel2:= darkgray else dunkel2:= black;
end;

procedure aendereFeld(x, y, farbe, wert: byte);
begin
  if feld[x, (y + 1) div 2] <> char(wert) then
  begin
    feld[x, (y + 1) div 2]:= char(wert);
    malFeld(x, y, farbe);
  end;
end;

procedure blockFeld(x, y: byte);
var
  y2: byte;
begin
  y2:= (y + 1) div 2;
  if odd(y) then
    case ord( feld[x, y2] ) of
      32: aendereFeld(x, y, red, 223);
      220: aendereFeld(x, y, red, 219);
    end
  else
    case ord( feld[x, y2] ) of
      32: aendereFeld(x, y, red, 220);
      223: aendereFeld(x, y, red, 219);
    end;
end;

procedure loescheFeld(x, y: byte);
var
  y2: byte;
begin
  y2:= (y + 1) div 2;
  if odd(y) then
    case ord( feld[x, y2] ) of
      219: aendereFeld(x, y, dunkel1(x), 220);
      223: aendereFeld(x, y, dunkel1(x), 32);
    end
  else
    case ord( feld[x, y2] ) of
      219: aendereFeld(x, y, dunkel2(x), 223);
      220: aendereFeld(x, y, dunkel2(x), 32);
    end;
end;

function txtLaenge(zk: string; laenge: byte): string;
begin
  if length(zk) > laenge then delete(zk, (laenge + 1), (length(zk) - laenge));
  while length(zk) < laenge do zk:= zk + ' ';
  txtLaenge:= zk;
end;

procedure dateiSpeichern( name: string );
var
  i, j: byte;
  datei: text;
  zeile: string;
begin
  assign( datei, name );
  {$i-}
  rewrite(datei);
  {$i+}
  if ioresult > 0 then
  begin
    closegraph;
    writeln;
    writeln('Error writing file''' + dateiname + '''!');
    write(' Press <Enter> to quit...');
    readln;
    halt;
  end
  else
  begin
    writeln( datei, '// vNibbles-Level');
    if (wandFarbe >= 0) and ( wandFarbe < 8) then
      writeln( datei, 'wall-color = ' + int2str(wandFarbe) );
    if (bodenFarbe > 7) and ( bodenFarbe < 16 ) then
      writeln( datei, 'background-color = ' + int2str(bodenFarbe) );
    for i:= 1 to 24 do
    begin
      zeile:= '';
      for j:= 1 to 80 do zeile:= zeile + feld[j, i];
      writeln( datei, zeile );
    end;
    close(datei);
  end;
end;

procedure farbenWaehlen;
var
  feldName: string;
  xPos, yPos, breit, rahmen, wXpos, wYpos: word;
  taste, i, farbe: byte;
  procedure zeigeFarbe(i: byte);
  var
    yPos: word;
  begin
    setfillstyle(1, i);
    if i < 8 then yPos:= wYpos else
    begin
      yPos:= wYpos + 2 * breit;
      dec(i, 8);
    end;
    bar( wXpos + i * breit, yPos, wXpos + (i + 1) * breit, yPos + breit );
  end;
  procedure zeigeFarben;
  begin
    versteckeCursor;
    setfillstyle(1, blue);
    bar( wXpos, wYpos + breit, maxx - wXpos, wYpos + 2 * breit );
    if bodenFarbe < 16 then
    begin
      setfillstyle(1, bodenFarbe);
      bar( wXpos + breit div 3 + (bodenFarbe - 8) * breit,
           wYpos + 2 * breit - 1, wXpos + 2 * (breit div 3) +
           (bodenFarbe - 8) * breit, wYpos + 2 * breit );
    end
    else setfillstyle(9, white);
    bar( wXpos + 1, wYpos + breit + 2, maxx - wXpos - 1, wYpos + 2 * breit - 2 );
    if wandFarbe < 8 then
    begin
      setfillstyle(1, wandFarbe);
      bar( wXpos + breit div 3 + wandFarbe * breit, wYpos + breit,
           wXpos + 2 * (breit div 3) + wandFarbe * breit,
           wYpos + round(1.6 * breit) );
    end
    else setfillstyle(4, white);
    bar( wXpos + breit div 3, wYpos + round(1.4 * breit),
         maxx - wXpos - breit div 3, wYpos + round(1.6 * breit) );
    zeigeCursor;
  end;
begin
  versteckeCursor;
  mausunit.erzeugeFeld('temp', '', 0, 0, maxx * xmf, maxy, 6, TRUE);
  setfillstyle(1, black);
  bar( 0, (maxy - mHoehe + 1), maxx, maxy );
  outtextxy( round(maxx / 120 * 8), maxy - 12, 'Choose the map''s colors!');
  rahmen:= maxx div 100;
  breit:= maxx div 15;
  wXpos:= 3 * breit;
  wYpos:= 3 * breit;
  setfillstyle(1, 1);
  bar(wXpos - rahmen, wYpos - rahmen, maxx - wXpos + rahmen, wYpos + 3 * breit + rahmen);
  erzeugeButton('weiter2', 'Save settings and quit', 'Continue', 11, blue, 4);
  for i:= 0 to 15 do
  begin
    zeigeFarbe(i);
    if i < 8 then
      mausunit.erzeugeFeld('c' + int2str(i), 'Wall Color #' + int2str(i),
       xmf * (wXpos + i * breit), wYpos, xmf * (wXpos + (i + 1) * breit),
        wYpos + breit, 7, TRUE)
    else
      mausunit.erzeugeFeld('c' + int2str(i), 'Background Color #' + int2str(i),
       xmf * (wXpos + (i - 8) * breit), wYpos + breit * 2, xmf * (wXpos +
        (i - 7) * breit), wYpos + breit * 3, 7, TRUE);
  end;
  setfillstyle(4, white);
  bar( wXpos + 8 * breit, wYpos, wXpos + 9 * breit, wYpos + breit );
  mausunit.erzeugeFeld('c16', 'Random Wall Color', xmf * (wXpos + 8 * breit),
    wYpos, xmf * (wXpos + 9 * breit), wYpos + breit, 7, TRUE);
  setfillstyle(9, white);
  bar( wXpos + 8 * breit, wYpos + 2 * breit, wXpos + 9 * breit, wYpos +  3 * breit );
  mausunit.erzeugeFeld('c17', 'Random Background Color', xmf * (wXpos + 8 * breit),
    wYpos + 2 * breit, xmf * (wXpos + 9 * breit), wYpos + 3 * breit, 7, TRUE);
  zeigeCursor;
  feldName:= 'c100';
  repeat
    if length(feldName) > 0 then
    if feldName[1] = 'c' then
    begin
      delete(feldName, 1, 1);
      farbe:= str2int(feldName);
      case farbe of
        0..7: wandFarbe:= farbe;
        8..15: bodenFarbe:= farbe;
        16: wandFarbe:= 88;
        17: bodenFarbe:= 88;
      end;
      zeigeFarben;
    end;
    maus(taste, feldName, xPos, yPos, FALSE);
  until feldName = 'weiter2';
  mausunit.loescheFeld('temp');
end;

procedure main;
var
  feldName, pfad: string;
  xPos, yPos: word;
  taste, xInt, yInt, xAlt, yAlt: byte;
  procedure getIntegers( xp, yp: word );
  begin
    xInt:= trunc( xp / (maxx / 80) + 1);
    yInt:= trunc( yp / ((maxy - mHoehe) / 48) + 1);
    if xInt > 80 then xInt:= 80;
    if yInt > 48 then yInt:= 48;
  end;
  procedure zeichnePunkt( xp, yp: word );
  begin
    xAlt:= xInt;
    yAlt:= yInt;
    getIntegers( xp, yp );
    if (xInt <> xAlt) or (yInt <> yAlt) then
    begin
      versteckeCursor;
      setfillstyle(1, black);
      bar(1, (maxy - 14), 8 * 12, maxy);
      outtextXY(10, (maxy - 12), int2str(xInt) + ';' + int2str(yInt));
      zeigeCursor;
    end;
    if taste = 1 then blockFeld( xInt, yInt ) else
      if taste = 2 then loescheFeld( xInt, yInt );
  end;
  procedure geradeZeichnen;
  var
    xStart, yStart, xOut, yOut: word;
    i, dx, dy: integer;
    faktor: real;
  begin
    mausunit.erzeugeFeld('temp', 'Click twice!', 0, 0, maxx * xmf, (maxy - mHoehe), 8, TRUE);
    mausunit.erzeugeFeld('bad', 'Click here to stop line-drawing', 0, (maxy - mHoehe + 1), maxx * xmf, maxy, 6, TRUE);
    repeat
      repeat
        maus(taste, feldName, xPos, yPos, FALSE);
      until taste > 0;
      if (feldName = 'temp') and (taste = 1) then
      begin
        xStart:= xPos div xmf;
        yStart:= yPos;
        setMouseWindow(0, 0, maxx * xmf, (maxy - mHoehe));
        SetWriteMode(XORPut);
        repeat
          xOut:= xPos div xmf;
          yOut:= yPos;
          maus(taste, feldName, xPos, yPos, TRUE);
          versteckeCursor;
          if (xStart <> xOut) or (yStart <> yOut) then
            line(xStart, yStart, xOut, yOut);
          line(xStart, yStart, xPos div xmf, yPos);
          zeigeCursor;
        until taste > 0;
        versteckeCursor;
        line(xStart, yStart, xPos div xmf, yPos);
        SetWriteMode(NormalPut);
        if taste = 1 then
        begin
          dx:= xOut - xStart;
          dy:= yOut - yStart;
          if betrag(dx) >= betrag(dy) then
          if dx = 0 then zeichnePunkt(xStart, yStart) else
          begin
            faktor:= dy / dx;
            if dx > 0 then
              for i:= 0 to dx do
                zeichnePunkt( (xStart + i), round(yStart + faktor * i) )
            else
              for i:= 0 downto dx do
                zeichnePunkt( (xStart + i), round(yStart + faktor * i) );
{                putpixel( (xStart + i), round(yStart + faktor * i), green )}
          end
          else
          if dy = 0 then zeichnePunkt(xStart, yStart) else
          begin
            faktor:= dx / dy;
            if dy > 0 then
              for i:= 0 to dy do
                zeichnePunkt( round(xStart + faktor * i), (yStart + i) )
            else
              for i:= 0 downto dy do
                zeichnePunkt( round(xStart + faktor * i), (yStart + i) );
          end
        end;
        zeigeCursor;
        setMouseWindow(0, 0, maxx * xmf, maxy);
      end;
    until (taste = 2) or (feldName = 'bad');
    mausunit.loescheFeld('temp');
    mausunit.loescheFeld('bad');
  end;
  procedure schlangenSetzen;
  var
    i, richtung: byte;
    ch: char;
    function allefelderFrei: boolean;
    var
      y2: byte;
      function obenFrei: boolean;
      var
        frei: boolean;
      begin
        if not(odd(yInt)) then frei:= true else
        if (richtung = 1) or (richtung = 3) then frei:= true else
        if ((feld[xInt, (y2 - 1)] = ' ') or (feld[xInt, (y2 - 1)] = char(223)))
        then frei:= true else frei:= false;
        obenFrei:= frei;
      end;
      function untenFrei: boolean;
      var
        frei: boolean;
      begin
        if odd(yInt) then frei:= true else
        if (richtung = 1) or (richtung = 3) then frei:= true else
        if ((feld[xInt, (y2 + 1)] = ' ') or (feld[xInt, (y2 + 1)] = char(220)))
        then frei:= true else frei:= false;
        untenFrei:= frei;
      end;
    begin
      y2:= (yInt + 1) div 2;
      if (xInt < 80) and (xInt > 1) and (y2 > 1) and (y2 < 24) and
        (feld[(xInt + 1), y2] = ' ') and (feld[xInt, y2] = ' ') and
         obenFrei and untenFrei then allefelderFrei:= TRUE else
      begin
        setfillstyle(1, red);
        versteckeCursor;
        bar( 0, (maxy - mHoehe + 1), maxx, maxy );
        outtextxy( (maxx - 34 * 8) div 2, (maxy - 12),
          'Not enough free space!');
        zeigeCursor;
        allefelderFrei:= FALSE;
      end;
    end;
  begin
    richtung:= 1;
    mausunit.erzeugeFeld('bad', 'Place snakes on the map!', 0, (maxy - mHoehe + 1), maxx * xmf, maxy, 6, TRUE);
    mausunit.erzeugeFeld('temp', 'lMouse: place | rMouse: turn', 0, 0, maxx * xmf, (maxy - mHoehe), 9, TRUE);
    for i:= 1 to 5 do
    begin
      setfillstyle(1, 1);
      versteckeCursor;
      bar( 0, (maxy - mHoehe + 1), maxx, maxy );
      outtextxy( (maxx - 34 * 8) div 2, (maxy - 12),
        'Choose player #' + int2str(i) + ' starting-position.');
      zeigeCursor;
      repeat
        repeat
          maus(taste, feldName, xPos, yPos, FALSE);
          if taste = 2 then
          begin
            if richtung < 4 then inc(richtung) else richtung:= 1;
            mausunit.loescheFeld('temp');
            mausunit.erzeugeFeld( 'temp', 'lMouse: place | rMouse: turn', 0, 0,
                                  maxx * xmf, (maxy - mHoehe), (8 + richtung), TRUE );
          end;
        until (taste = 1) and (feldName = 'temp');
        getIntegers( xPos div xmf, ypos );
      until allefelderFrei;
      malFeld( xInt, yInt, lightblue );
      case richtung of
      1: begin
           ch:= 'l';
           malFeld( (xInt + 1), yInt, blue );
         end;
      2: begin
           if odd(yInt) then ch:= 'u' else ch:= 'U';
           malFeld( xInt, (yInt + 1), blue );
         end;
      3: begin
           ch:= 'r';
           malFeld( (xInt - 1), yInt, blue );
           dec(xInt);
         end;
      4: begin
           ch:= 'd';
           malFeld( xInt, (yInt - 1), blue );
         end;
      end;
      feld[xInt, ((yInt + 1) div 2)]:= int2chr(i);
      if odd(yInt) and (upcase(ch) <> 'U') then
          feld[(xInt + 1), (yInt + 1) div 2]:= upcase(ch)
        else feld[(xInt + 1), (yInt + 1) div 2]:= ch;
    end;
    mausunit.loescheFeld('temp');
    mausunit.loescheFeld('bad');
  end;
begin
  moveto(3, (maxy - 12));
  outtext(graphini.graphinfo);
  if maxx - 319 > 8 * length(versionText) then outtext('  ' + versionText);
  repeat
    maus(taste, feldName, xPos, yPos, TRUE);
    if feldName = 'spiel' then zeichnePunkt( (xPos div xmf), yPos ) else
    if taste = 1 then
      if feldName = 'dateiname' then
      begin
        versteckeCursor;
        textEingabe(dateiname, 8, (maxx - 27 * 8), (maxy - 11), magenta);
        zeigeCursor;
      end
      else
      if feldName = 'gerade' then geradeZeichnen;
  until ( (feldName = 'ende') or (feldName = 'weiter') ) and (taste = 1);
  pfad:= paramstr(0);
  while (length(pfad) > 0) and (pfad[length(pfad)] <> '\') do
    delete(pfad, length(pfad), 1);
  if feldName = 'weiter' then
  begin
    schlangenSetzen;
    farbenWaehlen;
    dateiSpeichern( pfad + erweiterung(dateiname, '.vnl') );
  end
  else
  begin
    mndldemo.ausblenden;
    versteckeCursor;
    mndldemo.demoStart( pfad + 'zoomdemo.txt' );
  end;
end;

function holDateiname: string;
const
  erw = '.vnl';
var
  nummer: word;
  DirInfo: searchRec;
  neuName: string;
  nummerStr: string[4];
begin
  nummer:= 0;
  FindFirst(erweiterung(paramstr(1), erw), archive, DirInfo);
  if dosError = 0 then neuName:= paramstr(1) else
  repeat       {Name wie "map0001.vnl" erstellen}
    inc(nummer);
    nummerStr:= int2str(nummer);
    while length(nummerStr) < 4 do nummerStr:= '0' + nummerStr;
    neuName:= 'map' + nummerStr;
    findfirst(neuName + '.vnl', archive, DirInfo);
  until dosError <> 0;
  holDateiname:= neuName;
end;

procedure init;
var
  i, j: byte;
  datei: text;
  zeile: string;
  procedure zeigeFeld(x, y: byte);
  var
    y1, y2: byte;
  begin
    y1:= y * 2 - 1;
    y2:= y * 2;
    case feld[x, y] of
      char(219): begin
             malFeld( x, y1, red );
             malFeld( x, y2, red );
           end;
      char(220): begin
             malFeld( x, y1, dunkel1(x) );
             malFeld( x, y2, red );
           end;
      char(223): begin
             malFeld( x, y1, red );
             malFeld( x, y2, dunkel2(x) );
           end;
      else begin
             malFeld( x, y1, dunkel1(x) );
             malFeld( x, y2, dunkel2(x) );
           end;
    end;
  end;
begin
  bodenFarbe:= 88;
  wandFarbe:= 88;
  maxx:= getmaxx;
  maxy:= getmaxy;
  if maxx = 319 then xmf:= 2 else xmf:= 1;
  for i:= 1 to 80 do
    for j:= 1 to 24 do feld[i, j]:= ' ';
  assign(datei, erweiterung(dateiname, '.vnl'));
  {$i-}
  reset(datei);
  {$i+}
  i:= 0;
  if ioresult = 0 then
    while not eof(datei) do
    begin
      readln(datei, zeile);
      case upcase(zeile[1]) of
        'W': wandFarbe:= zeilenEndWert(zeile);
        'B': bodenFarbe:= zeilenEndWert(zeile);
        '/': if zeile[2] = '/' then;
        else
        begin
          inc(i);
          for j:= 1 to length(zeile) do
            if (zeile[j] = char(219)) or (zeile[j] = char(220)) or
              (zeile[j] = char(223)) then feld[j, i]:= zeile[j]
            else feld[j, i]:= ' ';
        end;
      end;
    end;
  dateiname:= nurName(dateiname);
  versteckeCursor;
  mausUnit.erzeugeFeld('alles', 'Copyright (C) Vlado 1999', 0, 0, maxx * xmf, maxy, 1, false);
  mausUnit.erzeugeFeld( 'spiel', 'lMouse: wall | rMouse: delete',
                        0, 0, (maxx * xmf), (maxy - mHoehe), 2, false );
  setColor(white);
  line(0, (maxy - mHoehe), maxx, (maxy - mHoehe));
  erzeugeButton('ende', 'Quit without saving', 'End', 4, red, 5);
  erzeugeButton('weiter', 'Place snakes, save and quit', 'Continue', 13, blue, 4);
  erzeugeButton('gerade', 'Draw a line', 'Line', 18, green, 7);
  erzeugeButton('dateiname', 'Filename (without DOS-extension)',
                 txtLaenge(dateiname, 8), 27, magenta, 3 );
  for i:= 1 to 80 do
    for j:= 1 to 24 do zeigeFeld(i, j);
  zeigeCursor;
end;

begin
  if graphinit('vga256', 2) then
    if mausunit.init then
    begin
      dateiname:= holDateiname;
      init;
      main;
      mausUnit.ende;
      closegraph;
    end
    else
    begin
      closegraph;
      writeln('Maustreiber nicht gefunden - Programm abgebrochen!');
      writeln('<Eingabe> drcken, um zu beenden...');
      readln;
    end;
end.